program energy_evaluation_afm_astroid;
uses graph,graph0,bgidriv,bgifont,dos,crt{,utils};

Const NLayers=3;    {ile warstw magn.}
      dimension=NLayers;
      MAX = 300;

TYPE
   glnarray = ARRAY [1..dimension] OF extended;
{   glnbyn = ARRAY [1..dimension,1..dimension] OF extended; }

const alpha1:real=0;
      alpha2:real=0;
      alpha3:real=0;

      dimm = 65;
      Ymagnify:real=5000.0; {500}
      YNormalize=10.0;
      ShowDimensions:integer=12;
var
   matrix : ARRAY [1..dimm,1..dimm] of real;
   theta: glnarray; {dla potrzeb 3D}
   X0, Y0, Z0, zoom, beta, phi: real;
   sinbeta,cosbeta,sinphi,cosphi:real;
   Xasp,Yasp:word;
   kp:char;
   ColorS: integer;
   twoPi:real;
   Ju1,Eeb,ku1,ku2,ku3,Hx,Hy,t1,t2,t3,Ms1,Ms2,Ms3,tstep:real;
   KAxis: integer;
   Nstep:integer;
   thetaini1,thetaini2,thetaini3,Hini:real;

   t,g:glnarray;    {theta1, theta2 oraz gradient}

   x : array [ 1..MAX ] of extended;
   ncom,a,nc: integer;
   pcom,xicom: glnarray;
   Magn,PrevMagn,ksi:extended;
   fout:text;
   ftol,fret :extended;
   iter,maxiter: integer;
   ii,jj,i,j : integer;
   lpom : integer;

   Ramp:real;         {default= 0.05;  Random amplitude}

   PageNo: boolean;

{ wprowadzam parametry funkcji  - initial variable parameters}

procedure initvar;
var
    i:integer;
begin
   write('Give linear Ju1=');
   readln(Input,Ju1);
   writeln(Ju1);
   write('Give exchange bias Eeb=');
   readln(Input,Eeb);
   writeln(Eeb);
   write('Give Ku1=');
   readln(Input,Ku1);
   writeln(Ku1);
   write('Give Ku2=');
   readln(Input,Ku2);
   writeln(Ku2);
   write('Give KuAF=');
   readln(Input,Ku3);
   writeln(Ku3);
   write('Give K Axis=');
   readln(Input,KAxis);
   writeln(KAxis);
   write('Give thickness1=');
   readln(Input,t1);
   writeln(t1);
   write('Give thickness2=');
   readln(Input,t2);
   writeln(t2);
   write('Give thickness3=');
   readln(Input,t3);
   writeln(t3);
   write('Give Ms1=');
   readln(Input,Ms1);
   writeln(Ms1);
   write('Give Ms2=');
   readln(Input,Ms2);
   writeln(Ms2);
   write('Give Ms3=');
   readln(Input,Ms3);
   writeln(Ms3);
   writeln;
   write('Give initial H=');
   readln(Input,Hini);
   write('Give H step=');
   readln(Input,Ksi);
   write('Give Steps No=');
   readln(Input,NStep);
   writeln('Maximum field=',Hini+NStep*Ksi:7:2);

   write('Random=');
   readln(Input,Ramp);
   writeln('RND =',Ramp:5:3);
   if (ParamCount>0) and not eof(Input) then
    begin
      readln(Input,alpha1);
      alpha1:=alpha1/180*Pi;
      writeln(alpha1);
      readln(Input,alpha2);
      alpha2:=alpha2/180*Pi;
      writeln(alpha2);
      readln(Input,alpha3);
      alpha3:=alpha3/180*Pi;
      writeln(alpha3);
    end;

{
   write('Give initial theta1=');
   readln(thetaini1);
   write('Give initial theta2=');
   readln(thetaini2);
}
  thetaini1:=-2*Pi;
  thetaini2:=-2*Pi;
  thetaini3:=-(2.5*Pi-alpha3);

  repeat until keypressed;
end;


procedure OpenParameterFile;
var PStr,OutStr:PathStr;
begin
  If ParamCount>=1 then
   PStr:=ParamStr(1)
  else PStr:='';
  If PStr<>'' then
  assign(Input,PStr);
{$I-}
  reset(Input);
{$I+}
If IOresult<>0 then begin writeln('Invalid file name!'); halt(0) end;
   if Pstr='' then OutStr:='mloop.dat'
    else
     OutStr:=Copy(PStr,1,Length(PStr)-4)+'.dat';
   InitVar;
   assign(fout,OutStr);
   rewrite(fout);
   writeln(fout,'J1=',Ju1:6,'   Eeb=',Eeb:4,'   K1=',ku1:5,'  K2=',ku2:5,'  Kaf=',ku3:5);
   writeln(fout,'t1=',t1:6,'   t2=',t2:4,', t3=',t3:4,'   Ms1=',Ms1:5,'  Ms2=',Ms2:5,'  Ms3=',Ms3:5);
   writeln(fout,'Hini=',Hini:6,'   Hstep=',Ksi:4,'   Nstep=',Nstep:5,'  Random=',Ramp);
   writeln(fout);
   writeln(fout,' Hx [A/m]                   Hy [A/m]');
   writeln(fout,'@');
   close(Input);
end;



{****************************************************************}
{TU ZACZYNAM WPROWADZAC SWOJA FUNKCJE }
{Function of Energy density }
{*****************************************************************}

function fnc(var t:glnarray ):extended;
var energia:real;
begin
 energia := -Ms1*t1*(Hx*cos(t[1])+Hy*sin(t[1])) -Ms2*t2*(Hx*cos(t[2])+Hy*sin(t[2])) {-Ms3*t3*(Hx*cos(t[3])+Hy*sin(t[3]))}
             -Eeb*cos(t[2]-t[3]) - Ju1*cos(t[1]-t[2]);
 case KAxis of
{anizotropia jednoosiowa}
  1 : energia:=energia -Ku1*t1*sqr(cos(t[1])) -Ku2*t2*sqr(cos(t[2])) -Ku3*t3*sqr(cos(t[3])) ;
{anizotropia kwadratowa}
  2 : energia:=energia-Ku1*t1*sqr(cos(t[1]))*sqr(sin(t[1])) -Ku2*t2*sqr(cos(t[2]))*sqr(sin(t[2]))
                      -Ku3*t3*sqr(cos(t[3]))*sqr(sin(t[3]));
 end;
 fnc:=energia*YNormalize;
end;

{*****************************************************}
{    koniec wprowadzania funkcji }
{*****************************************************}



{ $ I mnbrak1.pas}
{ $ I brent.pas}

{***************************************************}
{ PROCEDURA LICZACA GRADIENT MOJEJ FUNKCJI   }
{ Procedure computing gradient of FNC        }
{***************************************************}

procedure grad(var t:glnarray; var g:glnarray);
var sint12:real;
begin
{ procedura ta ma liczyc gradient funkcji danej }
  sint12:=sin(t[1]-t[2]);
  g[1]:=Ju1*sint12+Hx*Ms1*t1*sin(t[1])-Hy*Ms1*t1*cos(t[1]);
  g[2]:=-Ju1*sint12+Eeb*sin(t[2]-t[3])+Hx*Ms2*t2*sin(t[2])-Hy*Ms2*t2*cos(t[2]);
  g[3]:={+Hx*Ms3*t3*sin(t[3])-Hy*Ms3*t3*cos(t[3])}-Eeb*sin(t[2]-t[3]);

 case KAxis of
{anizotropia jednoosiowa}
 1 : begin
       g[1]:=g[1]+Ku1*t1*sin(2*t[1]);
       g[2]:=g[2]+Ku2*t2*sin(2*t[2]);
       g[3]:=g[3]+Ku3*t3*sin(2*t[3]);
     end;
{anizotropia kwadratowa}
 2 : begin
       g[1]:=g[1]-0.5*Ku1*t1*cos(4*(t[1]));
       g[2]:=g[2]-0.5*Ku2*t2*cos(4*(t[2]));
       g[3]:=g[3]-0.5*Ku3*t3*cos(4*(t[3]));
     end;
 end;

  g[1]:=g[1]*YNormalize;
  g[2]:=g[2]*YNormalize;
  g[3]:=g[3]*YNormalize;
end;

{************************************************* end }


function NormSampling:real;
const sampno=20;
var js:integer; suma:real;
    ts:glnarray;
begin
  suma:=1e-12;
  randomize;
  for js:=1 to sampno do
   begin
    ts[1]:=-2*Pi+4*Pi*random;
    ts[2]:=-2*Pi+4*Pi*random;
    ts[3]:=-2*Pi+4*Pi*random;
    suma:=suma+sqr(fnc(ts));
  end;
  suma:=sqrt(suma/sampno);
  NormSampling:=suma;
end;

function Magnetization(theta1,theta2,theta3:real):real;
var TotalT: real;
begin
{  Magnetization:=(Ms1*cos(theta1)+Ms2*cos(theta2))/NLayers; }
{srednia wazona:}
  TotalT:=0;
  if Ms1>0 then TotalT:=t1;
{  if Ms2>0 then TotalT:=TotalT+t2;
  if Ms3>0 then TotalT:=TotalT+t3; }
  if TotalT>0 then
   Magnetization:=(t1*Ms1*cos(theta1){+t2*Ms2*cos(theta2)+t3*Ms3*cos(theta3)})/(TotalT)
  else
   begin
    writeln('thickenss<=0');
    halt(0);
  end;
end;

{$I auxil.pas}


   procedure DisplayReal(PrefikS:string; InputReal:real;acc,X,Y:integer; SuffikS:String);
   var displej:string;
   begin
     Str(InputReal:8:acc,displej);
     SetColor(3);
     OutTextXY(X,Y,'                      ');
     OutTextXY(X,Y,PrefikS+displej+SuffikS);
   end;

{$I gradmin1.pas}

 function sign(x:real): real;
 begin
   if x<>0 then sign:=x/abs(x)
    else sign:=1.0;
 end;

procedure petelka(pdir: real);
 begin
   for ii:=1 to Nstep do
   begin
   SetVisualPage(ord(PageNo));
   SetActivePage(ord(not PageNo));
   ClearViewPort;
   ClearDevice;

   t[3]:=t[3]+Ramp-random(10)*Ramp/5;
   t[2]:=t[2]+Ramp-random(10)*Ramp/5;
   t[1]:=t[1]+Ramp-random(10)*Ramp/5;

   iter:= GradMin(t,1/NormSampling,0.1,ftol,maxiter);

   Magn:=Magnetization(Pi/2-alpha1-t[1],0,0);

   DisplayReal('M= ',Magn,2,520,280,' T');
   DisplayReal('t1=',t[1]/Pi,2,520,290,'Pi');
   DisplayReal('t2=',t[2]/Pi,2,520,300,'Pi');
   DisplayReal('t3=',t[3]/Pi,2,520,310,'Pi');
   DisplayReal('Hx=',Hx,0,520,320,' A/m');
   DisplayReal('Hy=',Hy,0,520,330,' A/m');
   DisplayReal('iter=',iter,0,520,340,' ');

   if Magn*PrevMagn<=0 then
        writeln(fout,Hx,' ',Hy);
{writeln(fout,Hx,' ',Magn);       }

   PrevMagn:=Magn;

   Hx:=Hx+Ksi*pdir;

   if keypressed then
     begin
         kp:=readkey;
         case kp of
          'q': begin jj:=NStep; ii:=NStep; end;
          end;
     end;

   PageNo:=not PageNo;
   {
   SetVisualPage(ord(not PageNo));
   SetActivePage(ord(PageNo));
   }
   delay(5);

   end; {petla przemagnesowania Hx}
 end;


Begin  {of the program}
   clrscr;

   twoPi:=2*Pi;

   {InitVar;}
   OpenParameterFile;
   {close(Input);}

                        LoadDrivers;
                        StartGraphScreen;
                        Xasp:=GetMaxX div 2;
                        Yasp:=GetMaxY div 2;

   ftol:=0.0000000002;
   maxiter:=9000;

   Hx:=Hini;

   Hy:=Hini;

   t[1]:=Pi/2;
   t[2]:=Pi/2; 
   t[3]:=thetaini3;


   {param grafiki 3D}
   X0:=0.3;
   Y0:=-0.1;
   Z0:=0.5;
   zoom:=35;

  PageNo:=False;
{
  SetVisualPage(ord(PageNo));
  SetActivePage(ord(not PageNo));
}

   for jj:=1 to Nstep do
    begin
     Hx:=Hini;
     PrevMagn:=sign(Hini);
     Magn:=PrevMagn;
     t[1]:=Pi/2;
     petelka(1);
     petelka(-1);
     Hy:=Hy+Ksi;
    end;  {petla Hy}

  repeat until keypressed;

  closegraph;


  close(fout);


   
end.