unit dataview2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, mctools, Buttons;

const
        {stale dla wyswietlania bloku danych}
        Maxdata=4096;
        maxdatar=7;
        {stale dla symulacji}
        NLayers=4;    {ile warstw magn.}
        dimension=NLayers;
        YNormalize=1.0;
type
  TDataArr = array[1..MaxData] of real;

  TPlotPattern = (NoPoint, DotPoint, LineSolid, XrossPoint);

  glnarray = ARRAY [1..dimension] OF extended;

  TForm1 = class(TForm)
    Image1: TImage;
    BOtworzDAT: TButton;
    OpenDialog1: TOpenDialog;
    BReplot1: TButton;
    RadioGroup_p: TRadioGroup;
    LabelMinX: TLabel;
    LabelMaxX: TLabel;
    LabelMaxY: TLabel;
    LabelMinY: TLabel;
    ScrollBarHP: TScrollBar;
    LabelXH: TLabel;
    LabelYH: TLabel;
    Edit1J: TEdit;
    Edit1M: TEdit;
    Edit1t: TEdit;
    Edit1K: TEdit;
    Edit2M: TEdit;
    Edit2t: TEdit;
    Edit2J: TEdit;
    Edit2K: TEdit;
    Edit3M: TEdit;
    Edit3t: TEdit;
    Edit3K: TEdit;
    Edit3J: TEdit;
    Edit4M: TEdit;
    Edit4t: TEdit;
    Edit4K: TEdit;
    Panel1: TPanel;
    RadioGroup_a: TRadioGroup;
    RadioButton2_ua: TRadioButton;
    RadioButton2_q: TRadioButton;
    ScrollBar1a: TScrollBar;
    GroupBox3_1aa: TGroupBox;
    RadioButton_1aplan: TRadioButton;
    RadioButton_1aperp: TRadioButton;
    ScrollBar2a: TScrollBar;
    GroupBox3_2aa: TGroupBox;
    RadioButton_2aplan: TRadioButton;
    RadioButton_2aperp: TRadioButton;
    ScrollBar3a: TScrollBar;
    GroupBox3_3aa: TGroupBox;
    RadioButton_3aplan: TRadioButton;
    RadioButton_3aperp: TRadioButton;
    Edit_stepF: TEdit;
    Edit_Nstep: TEdit;
    Edit_startF: TEdit;
    BitBtn1_Start: TBitBtn;
    Label_endF: TLabel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Timer1: TTimer;
    Label4: TLabel;
    SB1_Stop: TSpeedButton;
    Label5: TLabel;
    Label6: TLabel;
    RadioGroup_simdisp: TRadioGroup;
    RadioButton4_MvH: TRadioButton;
    RadioButton4_tt: TRadioButton;
    RadioButton4_MvHy: TRadioButton;
    RadioButton4_MvHz: TRadioButton;
    SB2_Reverse: TSpeedButton;
    BZapiszDAT: TButton;
    SaveDialog1: TSaveDialog;
    BReplot2: TButton;
    ScrollBar4a: TScrollBar;
    GroupBox3_4aa: TGroupBox;
    RadioButton_4aplan: TRadioButton;
    RadioButton_4aperp: TRadioButton;
    ScrollBarHA: TScrollBar;
    GroupBox2: TGroupBox;
    Edit_sp_Ramp: TEdit;
    Edit_sp_conv: TEdit;
    Edit_sp_maxiter: TEdit;
    Image2: TImage;
    RadioGroup_px: TRadioGroup;
    RadioGroup_py: TRadioGroup;
    BNormalizeSim: TButton;
    EditDR: TEdit;
    Label7: TLabel;
    RadioButton4_GMR: TRadioButton;
    Edit1J2: TEdit;
    Edit2J2: TEdit;
    procedure ClearScreen;
    procedure ClearVectorScreen;
    procedure ReplotVectorScreen;        
    procedure ReplotData(var Dx: TDataArr; var Dy: TDataArr; rowFilled: integer);
    procedure BOtworzDATClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BReplot1Click(Sender: TObject);
    procedure ScrollBarHPChange(Sender: TObject);
    procedure BitBtn1_StartClick(Sender: TObject);
    procedure Edit_startFChange(Sender: TObject);
    procedure Edit_NstepChange(Sender: TObject);
    procedure Edit_stepFChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SB1_StopClick(Sender: TObject);
    procedure SB2_ReverseClick(Sender: TObject);
    procedure BZapiszDATClick(Sender: TObject);
    procedure RadioGroup_pClick(Sender: TObject);
    procedure BReplot2Click(Sender: TObject);
    procedure ScrollBar1aChange(Sender: TObject);
    procedure ScrollBar2aChange(Sender: TObject);
    procedure ScrollBar3aChange(Sender: TObject);
    procedure ScrollBar4aChange(Sender: TObject);
    procedure ScrollBarHAChange(Sender: TObject);
    procedure RadioGroup_pxClick(Sender: TObject);
    procedure RadioGroup_pyClick(Sender: TObject);
    procedure BNormalizeSimClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  DataExp: array[1..maxdatar] of TDataArr;  {do wczytywania}
  DataSim: array[1..maxdatar] of TDataArr;  {do symulacji}

  fin: Text;
  fout: Text;
  datpath: string;

  rowFilled: integer;
  colFilled: integer;
  rowSimul: integer;

  actX: integer;
  actY: integer; {aktualna os DataExp do rysowania}
  actSx: integer;
  actSy: integer; {aktualna os DataSim do rysowania}
  plotpattern: TPlotPattern;
  psize: integer;
  hilitP: integer;

{zmienne do symulacji}
  Ms, ti, Ku, alpha: glnarray;  {namagnesowanie nasycenia, grubosc, anizotropia i jej kat}
  Ju, Ju2: glnarray; {energia sprzezenia miedzy warstwami}
  KType: integer;  {typ anizotropii, 1: prostopadla, 2: kubiczna}
  KAxis: integer;  {polozenie osi a.: 1: w plaszczyznie, 2: prostopadle}
  Nstep:integer;   {ilosc krokow symulacji}
  thetaini1,thetaini2,thetaini3,Hini,Hfin,deltaH,HAngle:real;

  t,g:glnarray;    {theta1, theta2 oraz gradient}

  Ramp:real;         {default= 0.05;  Random amplitude}
  st: integer; {numer kroku}
  Hx,Hy,HTotal: real;
  MagnTotal: real;
  TotalEnergy: extended;

  ftol :extended;
  iter,maxiter: integer;

implementation

{$R *.DFM}

function fnc(var t:glnarray ):extended;
var energia:real;
    l: integer;
begin
 energia := 0;
 for l:=1 to NLayers do
  begin
    if ti[l]>0 then
     begin

       Hx:=Htotal*cos(Hangle);
       Hy:=Htotal*sin(Hangle);
{       Hz:=0; !!! poprawic potem}

       energia:=energia -Ms[l]*ti[l]*(Hx*cos(t[l])+Hy*sin(t[l]));
       case KAxis of
        {anizotropia jednoosiowa}
        1 : energia:=energia -Ku[l]*ti[l]*sqr(cos(t[l]-alpha[l]));
        {anizotropia kwadratowa}
        2 : energia:=energia-Ku[l]*ti[l]*sqr(cos(t[l]-alpha[l]))*sqr(sin(t[l]-alpha[l]));
       end;
       if Ju[l]<>0 then
        begin
         if l<NLayers then
          if ti[l+1]>0 then
           energia:=energia -Ju[l]*cos(t[l]-t[l+1]);
        end;
       if Ju2[l]<>0 then
        begin
         if l<NLayers then
          if ti[l+1]>0 then
           energia:=energia -Ju2[l]*cos(t[l]-t[l+1])*cos(t[l]-t[l+1]);
        end;

     end;
   end;
 fnc:=energia;
end;

{***************************************************}
{ PROCEDURA LICZACA GRADIENT MOJEJ FUNKCJI   }
{ Procedure computing gradient of FNC        }
{***************************************************}

procedure grad(var t:glnarray; var g:glnarray);
var l:integer;
begin
 for l:=1 to NLayers do
  begin
    g[l]:=0;
    if ti[l]>0 then
     begin
       Hx:=Htotal*cos(Hangle);
       Hy:=Htotal*sin(Hangle);
{       Hz:=0;                   !!! poprawic potem}

       g[l]:=g[l]+Hx*Ms[l]*ti[l]*sin(t[l])-Hy*Ms[l]*ti[l]*cos(t[l]);
       case KAxis of
        {anizotropia jednoosiowa}
        1 : g[l]:=g[l] +Ku[l]*ti[l]*sin(2*(t[l]-alpha[l]));
        {anizotropia kwadratowa}
        2 : g[l]:=g[l] -0.5*Ku[l]*ti[l]*cos(4*(t[l]-alpha[l]));
      end;
    {sprzezenie biliniowe}
      if Ju[l]<>0 then
       begin
        if l<NLayers then
         if ti[l+1]>0 then
          g[l]:=g[l] +Ju[l]*sin(t[l]-t[l+1]);
       end;
      if l>1 then
       if ti[l-1]>0 then
        if Ju[l-1]<>0 then
         g[l]:=g[l] -Ju[l-1]*sin(t[l-1]-t[l]);
    {sprzezenie bikwadratowe}
      if Ju2[l]<>0 then
       begin
        if l<NLayers then
         if ti[l+1]>0 then
          g[l]:=g[l] +Ju2[l]*cos(t[l]-t[l+1])*sin(t[l]-t[l+1]);
       end;
      if l>1 then
       if ti[l-1]>0 then
        if Ju[l-1]<>0 then
         g[l]:=g[l] -Ju2[l-1]*cos(t[l-1]-t[l])*sin(t[l-1]-t[l]);
     end;
    g[l]:=g[l];
  end;
end;
{************************************************* end }

function Magnetization(var t:glnarray):real;
var TotalT,TotalM: real;
    l:integer;
begin
{  Magnetization:=(Ms1*cos(theta1)+Ms2*cos(theta2))/NLayers; }
{srednia wazona:}
  TotalT:=0;
  TotalM:=0;
  for l:=1 to NLayers do
   begin
     if (Ms[l]>0) and (ti[l]>0) then
      begin
        TotalT:=TotalT+ti[l];
        if Form1.RadioButton4_MvHy.Checked then
         TotalM:=TotalM+ti[l]*Ms[l]*sin(t[l])
        else        {poprawic to zeby bylo Hz}
         TotalM:=TotalM+ti[l]*Ms[l]*cos(t[l])
      end;
   end;
   if TotalT>0 then
    Magnetization:=TotalM/TotalT
  else
   begin
    Magnetization:=0.0;
   end;
end;

procedure ClearExpData;
var i, j: integer;
begin
  for i:=1 to maxdatar do
   for j:=1 to Maxdata do
    DataExp[i,j]:=0.0;
  rowFilled:=0;
  colFilled:=0;
end;

procedure ClearSimData;
var i, j: integer;
begin
  for i:=1 to maxdatar do
   for j:=1 to Maxdata do
    DataSim[i,j]:=0.0;
  rowSimul:=0;
end;

procedure XAutoScaling(var Dx: TDataArr; rowFilled: integer);
var ii: integer;
begin
  if rowFilled>0 then
   begin
     XMax:=0; XMin:=0;
     for ii:=1 to rowFilled do
      begin
       if Dx[ii]<XMin then
        XMin:=Dx[ii];
       if Dx[ii]>XMax then
        XMax:=Dx[ii];
      end;
     Xmin:=Xmin-abs(Xmin*0.1);
     Xmax:=Xmax+abs(Xmax*0.1);
   end;
end;

procedure YAutoScaling(var Dy: TDataArr; rowFilled: integer);
var ii: integer;
begin
  if rowFilled>0 then
   begin
     YMax:=0; YMin:=0;
     for ii:=1 to rowFilled do
      begin
       if Dy[ii]<YMin then
        YMin:=Dy[ii];
       if Dy[ii]>YMax then
        YMax:=Dy[ii];
      end;
     Ymin:=Ymin-abs(Ymin*0.1);
     Ymax:=Ymax+abs(Ymax*0.1);
   end;
end;

procedure PlotXAxis;
begin
 with Form1 do
  begin
    Image1.Canvas.MoveTo(Horiz(XMin),Vert(0.0));
    Image1.Canvas.LineTo(Horiz(XMax),Vert(0.0));
  end;
end;

procedure PlotYAxis;
begin
 with Form1 do
  begin
    Image1.Canvas.MoveTo(Horiz(0.0),Vert(YMin));
    Image1.Canvas.LineTo(Horiz(0.0),Vert(YMax));
  end;
end;

procedure PlotXYPoint(xp: real; yp: real; pp: TPlotPattern; ps: integer);
begin
  with Form1.Image1 do
  case pp of
   NoPoint: Canvas.MoveTo(Horiz(xp),Vert(yp));
   DotPoint: Canvas.Pixels[Horiz(xp),Vert(yp)]:=clBlue;
   LineSolid: begin
                Canvas.LineTo(Horiz(xp),Vert(yp));
              end;
   XrossPoint: begin
                 Canvas.MoveTo(Horiz(xp)-ps,Vert(yp));
                 Canvas.LineTo(Horiz(xp)+ps,Vert(yp));
                 Canvas.MoveTo(Horiz(xp),Vert(yp)-ps);
                 Canvas.LineTo(Horiz(xp),Vert(yp)+ps);
                 Canvas.MoveTo(Horiz(xp),Vert(yp));
               end;
    else
      Canvas.MoveTo(Horiz(xp),Vert(yp));
  end;
end;

procedure TForm1.ClearScreen;
var fulls: TRect;
begin
     case RadioGroup_p.ItemIndex of
        0 : plotpattern:=NoPoint;
        1 : plotpattern:=DotPoint;
        2 : plotpattern:=LineSolid;
        3 : plotpattern:=XrossPoint;
     end;
     fulls.Left:=0;
     fulls.Top:=0;
     fulls.Right:=Image1.Width;
     fulls.Bottom:=Image1.Height;
     Hsize:=fulls.Right-fulls.Left;
     Vsize:=fulls.Bottom-fulls.Top;
     Hstep:= (Xmax - Xmin) / Hsize;
     Vstep:= (Ymax - Ymin) / Vsize;
     Image1.Canvas.FillRect(fulls);
     Image1.Canvas.Pen.Color:=clGray;
     PlotXAxis; PlotYAxis;
     LabelMinX.Caption:=FloatToStrF(XMin,ffGeneral,5,10);
     LabelMaxX.Caption:=FloatToStrF(XMax,ffGeneral,5,10);
     LabelMinY.Caption:=FloatToStrF(YMin,ffGeneral,5,10);
     LabelMaxY.Caption:=FloatToStrF(YMax,ffGeneral,5,10);
end;

procedure TForm1.ClearVectorScreen;
var xd0,yd0: real;
    i: integer;
begin
    Image2.Canvas.Pen.Style:=psSolid;
    Image2.Canvas.Brush.Color:=clLtGray;
    Image2.Canvas.Pen.Color:=clBlack;
    Image2.Canvas.Ellipse(0,0,Image2.Width,Image2.Height);
    Image2.Canvas.Pen.Style:=psDot;
    for i:=1 to NLayers do
     begin
       xd0:=cos(alpha[i]);
       yd0:=sin(alpha[i]);
       case i of
        1: Image2.Canvas.Pen.Color:=clPurple;
        2: Image2.Canvas.Pen.Color:=clBlue;
        3: Image2.Canvas.Pen.Color:=clGreen;
        4: Image2.Canvas.Pen.Color:=clYellow;
       end;
       Image2.Canvas.MoveTo(Trunc(Image2.Width*(1-xd0)/2),Trunc(Image2.Height*(1+yd0)/2));
       Image2.Canvas.LineTo(Trunc(Image2.Width*(1+xd0)/2),Trunc(Image2.Height*(1-yd0)/2));
     end;
    Image2.Canvas.Pen.Style:=psSolid;
    Image2.Canvas.Pen.Color:=clBlack;
    xd0:=cos(Hangle)*sign(Hini);
    yd0:=sin(Hangle)*sign(Hini);
    Image2.Canvas.MoveTo(Image2.Width div 2,Image2.Height div 2);
    Image2.Canvas.LineTo(Trunc(Image2.Width*(1+xd0)/2),Trunc(Image2.Height*(1-yd0)/2));
end;

procedure TForm1.ReplotVectorScreen;
var xd0,yd0: real;
    i: integer;
begin
    ClearVectorScreen;
    Image2.Canvas.Pen.Style:=psSolid;
    for i:=1 to NLayers do
     begin
       xd0:=cos(t[i]);
       yd0:=sin(t[i]);
       case i of
        1: Image2.Canvas.Pen.Color:=clPurple;
        2: Image2.Canvas.Pen.Color:=clBlue;
        3: Image2.Canvas.Pen.Color:=clGreen;
        4: Image2.Canvas.Pen.Color:=clYellow;
       end;
       Image2.Canvas.MoveTo(Image2.Width div 2,Image2.Height div 2);
       Image2.Canvas.LineTo(Trunc(Image2.Width*(1+xd0)/2),Trunc(Image2.Height*(1-yd0)/2));
     end;
    Image2.Canvas.Pen.Color:=clBlack;
end;

procedure TForm1.ReplotData(var Dx: TDataArr; var Dy: TDataArr; rowFilled: integer);
var ii,jj: integer;
begin
  Image1.Canvas.Pen.Color:=clBlack;
  Image1.Canvas.MoveTo(Horiz(Dx[1]),Vert(Dy[1]));
  for ii:=1 to rowFilled do
   begin
    PlotXYPoint(Dx[ii],Dy[ii],plotpattern,psize);
    if ii=hilitP then
     begin
       Image1.Canvas.Pen.Color:=clRed;
       PlotXYPoint(Dx[ii],Dy[ii],XrossPoint,8);
       Image1.Canvas.Pen.Color:=clBlack;
     end;
   end;
end;

procedure PlotNewData;
begin
{  hilitP:=-1; }
  if rowFilled>0 then
   begin
     Form1.ScrollBarHP.Enabled:=true;
     Form1.ScrollBarHP.Max:=rowFilled;
   end;
  if rowFilled>0 then
   begin

     XAutoScaling(DataExp[ActX],rowFilled);
     YAutoScaling(DataExp[ActY],rowFilled);
     Form1.ClearScreen;
     Form1.ReplotData(DataExp[ActX],DataExp[ActY],rowFilled);
   end
    else
     if rowSimul>0 then
     begin
       Form1.ClearScreen;
       XAutoScaling(DataSim[ActX],rowSimul);
       YAutoScaling(DataSim[ActY],rowSimul);
       plotpattern:=LineSolid;
       Form1.ReplotData(DataSim[ActX],DataSim[ActY],rowSimul);
     end;
end;

procedure TForm1.BOtworzDATClick(Sender: TObject);
var
   s:string;
   testf: real;
   datafileOK:boolean;
   ii: integer;
function TryReadNext(cn: integer): boolean;
 begin
    s:=ReadWord(fin);
    testf:=-666;
    if (s<>'') and not eof(fin) then
     begin
       try
        testf := StrToFloat(s);
       except
        on EConvertError do
         datafileOK:=false;
       end;
       if testf<>-666 then
        datafileOK:=true;
       if datafileOK then
        begin
         colFilled:=cn+1;          {wczytana kolejna kolumna pierwszego wiersza}
         DataExp[colFilled,rowFilled]:=testf;
        end;
     end
    else
     datafileOK:=false;
    TryReadNext:=datafileOK;
 end;
begin
 ClearExpData;
 s:='';
 datpath:='';
 OpenDialog1.FileName:='';
 testf:=-666; {taka diabelska sztuczka}
 datafileOK:=false;
 OpenDialog1.Execute;
 datpath:=OpenDialog1.FileName;
 if datpath<>'' then
  begin
   assignfile(fin,datpath);
{$I-}
   reset(fin);
{$I+}
   case OpenDialog1.FilterIndex of
   1: begin
        if IOresult=0 then
         begin                  {proba czytania naglowka DA2}
           datafileOK:=true;
           s:=ReadWord(fin);
{           Label1.Caption:=s; }
           try
            testf := StrToFloat(s);
           except
            on EConvertError do
             begin
               datafileOK:=false;
               testf:=-666;
             end;
      {      BOtworzDAT.Enabled:=false;}
           end;

           if datafileOK then
            begin                       {wczytana pierwsza kolumna pierwszego wiersza}
              rowFilled:=1;
              colFilled:=1;
              DataExp[colFilled,rowFilled]:=testf;
              s:=ReadWord(fin);
              testf:=-666;
              if (s<>'') and not eof(fin) then
               begin
                 try
                  testf := StrToFloat(s);
                 except
                  on EConvertError do
                   datafileOK:=false;
                 end;
                 if datafileOK then
                  begin
                   colFilled:=2;          {wczytana druga kolumna pierwszego wiersza}
                   DataExp[colFilled,rowFilled]:=testf;
                  end;
               end;
              if datafileOK then
               while not (eof(fin) or (rowFilled>MaxData)) do
                begin
                  readln(fin);
                  if not eof(fin) then
                   begin
                     inc(rowFilled);
                     for ii:=1 to colFilled do
                      read(fin,DataExp[ii,rowFilled]);
                   end;
                end;
            end;
{           Label1.Caption:=s; }
           closefile(fin);
         end;
      end; {IndexFilter=1}
   2: begin
        if IOresult=0 then
         begin                  {proba czytania naglowka}
           datafileOK:=true;
           s:=ReadWord(fin);
           Label1.Caption:=s;
           try
            testf := StrToFloat(s);
           except
            on EConvertError do
             begin
               testf:=-666;
             end;
            end;
           if testf=-666 then
            begin  {szukaj @ a potem wczytuj}
             while (s<>'@') and (not eof(fin)) do
              begin
                while (s<>'@') and (s<>'') do
                 s:=ReadWord(fin);
                if (s<>'@') and eof(fin) then
                 datafileOK:=false
                else
                 if (s<>'@') then
                  begin
                    if eoln(fin) then
                     readln(fin);
                    s:=ReadWord(fin);
                  end;
              end;
             if (s='@') then
              begin
                readln(fin);
                s:=ReadWord(fin);
                Label1.Caption:=s;
                testf:=StrToFloat(s);
                datafileOK:=true;
            end;
      {      BOtworzDAT.Enabled:=false;}
           end;

           if datafileOK and (testf<>-666) then
            begin                       {wczytana pierwsza kolumna pierwszego wiersza}
              rowFilled:=1;
              colFilled:=1;
              DataExp[colFilled,rowFilled]:=testf;
              while TryReadNext(colFilled) do
                begin
                end;
{              if datafileOK then}
               while not (eof(fin) or (rowFilled>MaxData)) do
                begin
                  readln(fin);
                  if not eof(fin) then
                   begin
                     inc(rowFilled);
                     for ii:=1 to colFilled do
                      read(fin,DataExp[ii,rowFilled]);
                   end;
                end;
            end;
           Label1.Caption:=s;
           closefile(fin);
         end;
      end; {IndexFilter=2}
    end; {case}
  end; {datpath<>''}
 if rowFilled>0 then
  PlotNewData;
end;

procedure TForm1.BReplot1Click(Sender: TObject);
begin
  PlotNewData;
end;

procedure TForm1.ScrollBarHPChange(Sender: TObject);
begin
  with ScrollBarHP do
   hilitP:=Round(rowFilled*Position/(Max-Min));
  if hilitP>0 then
   LabelXH.Caption:=FloatToStrF(DataExp[actX,hilitP],ffGeneral,6,12)
  else
   LabelXH.Caption:='XHighlit';
  if hilitP>0 then
   LabelYH.Caption:=FloatToStrF(DataExp[actY,hilitP],ffGeneral,6,12)
  else
   LabelYH.Caption:='YHighlit';
  {ReplotData(DataExp[ActX],DataExp[ActY],rowFilled);}
  PlotNewData;
end;

procedure TForm1.Edit_startFChange(Sender: TObject);
begin
  Hini:=StrToFloat(Edit_startF.Text);
  Nstep:=StrToInt(Edit_Nstep.Text);
  deltaH:=StrToFloat(Edit_stepF.Text);
  Hfin:=Hini+deltaH*Nstep;
  Label_endF.Caption:='fin. field: '+FloatToStrF(Hfin,ffGeneral,4,5)+' kA/m';
end;

procedure TForm1.Edit_NstepChange(Sender: TObject);
begin
  Hini:=StrToFloat(Edit_startF.Text);
  Nstep:=StrToInt(Edit_Nstep.Text);
  deltaH:=StrToFloat(Edit_stepF.Text);
  Hfin:=Hini+deltaH*Nstep;
  Label_endF.Caption:='fin. field: '+FloatToStrF(Hfin,ffGeneral,4,5)+' kA/m';
end;

procedure TForm1.Edit_stepFChange(Sender: TObject);
begin
  Hini:=StrToFloat(Edit_startF.Text);
  Nstep:=StrToInt(Edit_Nstep.Text);
  deltaH:=StrToFloat(Edit_stepF.Text);
  Hfin:=Hini+deltaH*Nstep;
  Label_endF.Caption:='fin. field: '+FloatToStrF(Hfin,ffGeneral,4,5)+' kA/m';
end;

{$I gradmin1.pas}


procedure TForm1.BitBtn1_StartClick(Sender: TObject);
var l:integer;
begin
  rowSimul:=0;
  st:=0;
  Ymin:=-0.01;
  Ymax:=0.01;
  {inicjalizacja}
  Ms[1]:=StrToFloat(Edit1M.Text);
  Ms[2]:=StrToFloat(Edit2M.Text);
  Ms[3]:=StrToFloat(Edit3M.Text);
  Ms[4]:=StrToFloat(Edit4M.Text);
  ti[1]:=StrToFloat(Edit1t.Text);
  ti[2]:=StrToFloat(Edit2t.Text);
  ti[3]:=StrToFloat(Edit3t.Text);
  ti[4]:=StrToFloat(Edit4t.Text);
  Ku[1]:=StrToFloat(Edit1K.Text);
  Ku[2]:=StrToFloat(Edit2K.Text);
  Ku[3]:=StrToFloat(Edit3K.Text);
  Ku[4]:=StrToFloat(Edit4K.Text);
  Ju[1]:=StrToFloat(Edit1J.Text);
  Ju2[1]:=StrToFloat(Edit1J2.Text);
  Ju[2]:=StrToFloat(Edit2J.Text);
  Ju2[2]:=StrToFloat(Edit2J2.Text);
  Ju[3]:=StrToFloat(Edit3J.Text);
  Ju2[3]:=0;
  Ju[4]:=0; Ju2[4]:=0;
  Ramp:=StrToFloat(Edit_sp_Ramp.Text);
  ftol:=StrToFloat(Edit_sp_conv.Text);
  maxiter:=StrToInt(Edit_sp_maxiter.Text);
  alpha[1]:=ScrollBar1a.Position*Pi/180;
  alpha[2]:=ScrollBar2a.Position*Pi/180;
  alpha[3]:=ScrollBar3a.Position*Pi/180;
  alpha[4]:=ScrollBar4a.Position*Pi/180;
  Hangle:=ScrollBarHA.Position*Pi/180;
  if RadioButton2_ua.Checked then KAxis:=1
   else
    if RadioButton2_q.Checked then KAxis:=2
     else KAxis:=0;

  Hini:=StrToFloat(Edit_startF.Text);
  Nstep:=StrToInt(Edit_Nstep.Text);
  deltaH:=StrToFloat(Edit_stepF.Text);
  Hfin:=Hini+deltaH*Nstep;
  Label_endF.Caption:='fin. field: '+FloatToStrF(Hfin,ffGeneral,4,5)+' kA/m';
{scaling}
  if RadioButton4_tt.Checked then
   begin
     actSx:=3;
     actSy:=4;
     plotpattern:=XrossPoint;
     Xmin:=-2*Pi; Xmax:=2*Pi;
     Ymin:=-2*Pi; Ymax:=2*Pi;
     ClearScreen;
   end;
  if RadioButton4_GMR.Checked then
   begin
      Ymin:=0;
      Ymax:=StrToFloat(EditDR.Text);
      if Hini<Hfin then
       begin
         Xmin:=Hini*1000;
         Xmax:=Hfin*1000;
       end
      else
       if Hini>Hfin then
        begin
          Xmin:=Hfin*1000;
          Xmax:=Hini*1000;
        end;
      ClearScreen;
   end;
  if RadioButton4_MvH.Checked then
   begin
      actSx:=1;
      actSy:=2;
      if Hini<Hfin then
       begin
         Xmin:=Hini*1000;
         Xmax:=Hfin*1000;
         for l:=1 to NLayers do
          t[l]:=0;
         Ymax:=Ymax+Magnetization(t);
         for l:=1 to NLayers do
          t[l]:=-Pi;
         Ymin:=Ymin+Magnetization(t);
       end
      else
       if Hini>Hfin then
        begin
          Xmin:=Hfin*1000;
          Xmax:=Hini*1000;
         for l:=1 to NLayers do
          t[l]:=-Pi;
         Ymin:=Ymin+Magnetization(t);
         for l:=1 to NLayers do
          t[l]:=0;
         Ymax:=Ymax+Magnetization(t);
        end
         else Xmax:=1;
      ClearScreen;
      if rowFilled>0 then
       ReplotData(DataExp[ActX],DataExp[ActY],rowFilled); {dane exp. jako tlo}
      plotpattern:=LineSolid;
   end;
  if RadioButton4_MvHy.Checked then
   begin
      actSx:=1;
      actSy:=2;
      if Hini<Hfin then
       begin
         Xmin:=Hini*1000;
         Xmax:=Hfin*1000;
         for l:=1 to NLayers do
          t[l]:=Pi/2;
         Ymax:=Ymax+Magnetization(t);
         for l:=1 to NLayers do
          t[l]:=-Pi/2;
         Ymin:=Ymin+Magnetization(t);
       end
      else
       if Hini>Hfin then
        begin
          Xmin:=Hfin;
          Xmax:=Hini;
         Xmin:=Hini;
         Xmax:=Hfin;
{         for l:=1 to NLayers do
          t[l]:=-Pi/2;
         Ymin:=Ymin+Magnetization(t);
         for l:=1 to NLayers do
          t[l]:=Pi/2;
         Ymax:=Ymax+Magnetization(t);
}       Ymin:=Ymin-Ms[1];
        Ymax:=Ymax+Ms[1]; {prowizorka}
        end
         else Xmax:=1;
      ClearScreen;
      if rowFilled>0 then
       ReplotData(DataExp[ActX],DataExp[ActY],rowFilled); {dane exp. jako tlo}
      plotpattern:=LineSolid;
   end;
  BitBtn1_Start.Enabled:=False;
  SB1_Stop.Enabled:=True;
  Timer1.Enabled:=True; {mozna uruchomic}
end;

procedure TForm1.FormCreate(Sender: TObject);
var i,j:integer;
begin
  Xmin := 0.0;
  Xmax := 1.0;
  Ymin := 0.0;
  Ymax := 1.0;
  datpath:='';
  ClearExpData;
  ClearSimData;
  plotpattern:={LineSolid;} XrossPoint;
  actX:=1;
  actY:=2;
  actSx:=1;
  actSy:=2;
  psize:=2;
  hilitP:=-1;

  thetaini1:=1.5;
  thetaini2:=0;
  thetaini3:=0;
  Ramp:=0.0005;{0.05;}
  Hx:=0;
  Hy:=0;
  HTotal:=0;
  MagnTotal:=0;
  TotalEnergy:=0;
  KAxis:=0;
  KType:=0;
  HAngle:=0;
  Hini:=StrToFloat(Edit_startF.Text);
  Nstep:=StrToInt(Edit_Nstep.Text);
  deltaH:=StrToFloat(Edit_stepF.Text);

  ftol:=0.0000000002;
  maxiter:=66599;

  ClearVectorScreen;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var l,i:integer;
    YNormalize: real;
    test: glnarray;
begin
     Timer1.Enabled:=False;
     inc(st);
     YNormalize:=1.0e-10;
{>>>>>>>>>>>>main loop start here:::::::::::::}
     Htotal:=1000.0*(Hini+st*deltaH);
     inc(rowSimul);
     {normalization:}
     for l:=1 to NLayers do
      begin
        t[l]:=t[l]+Ramp-random(10)*Ramp/5.0;
      end;
     YNormalize:=YNormalize+sqr(fnc(t));
     for i:=1 to 10 do
     begin
       for l:=1 to NLayers do
        test[l]:=random(6)-3;
       YNormalize:=YNormalize+sqr(fnc(test));
     end;
     YNormalize:=sqrt(YNormalize);
     {normalization.}

     {gradient seeking:}
     iter:= GradMin(t,1/YNormalize,0.1,ftol,maxiter);
     MagnTotal:=Magnetization(t);
     TotalEnergy:=fnc(t);

     DataSim[1,rowSimul]:=Htotal;
     DataSim[2,rowSimul]:=MagnTotal;
     if ti[1]>0 then
      Datasim[3,rowSimul]:=t[1];
     if ti[2]>0 then
      DataSim[4,rowSimul]:=t[2];
     if ti[3]>0 then
      DataSim[5,rowSimul]:=t[3];
     if ti[4]>0 then
      DataSim[6,rowSimul]:=t[4];
     DataSim[7,rowSimul]:=StrToFloat(EditDR.Text)*(1-cos(t[1]-t[2]))/2;
     if RadioButton4_MvH.Checked or RadioButton4_MvHy.Checked then
      begin
        actSx:=1;
        actSy:=2;
      end;
     if RadioButton4_tt.Checked then
      begin
        actSx:=3;
        actSy:=4;
      end;
     if RadioButton4_GMR.Checked then
      begin
        actSx:=1;
        actSy:=7;
      end;

{<<<<<<<<<<<<<<<end of main loop.............}

     if ti[1]>0 then
      Label1.Caption:=FloatToStrF(t[1],ffGeneral,5,10);
     if ti[2]>0 then
      Label2.Caption:=FloatToStrF(t[2],ffGeneral,5,10);
     if ti[3]>0 then
      Label3.Caption:=FloatToStrF(t[3],ffGeneral,5,10);
     Label7.Caption:=FloatToStrF(t[4],ffGeneral,5,10);
     Label4.Caption:=FloatToStrF(TotalEnergy,ffGeneral,5,10);
     Label5.Caption:=IntToStr(iter);
     Label6.Caption:=IntToStr(st);
{     PlotNewData; }
{     Form1.ReplotData(DataSim[ActX],DataSim[ActY],rowSimul);}
     if (rowSimul=1) then
       Form1.ReplotData(DataSim[ActX],DataSim[ActY],rowSimul)
      else
       PlotXYPoint(DataSim[actSx,rowSimul],DataSim[actSy,rowSimul],plotpattern,3);
     ReplotVectorScreen;  
     if st<=Nstep then
      begin
        Timer1.Enabled:=True;  {licz nastepny}
      end
       else
        begin
          BitBtn1_Start.Enabled:=True; {koniec liczenia}
          SB1_Stop.Enabled:=False;
          SB2_Reverse.Enabled:=True;
          BZapiszDAT.Enabled:=True;
        end;
end;

procedure TForm1.SB1_StopClick(Sender: TObject);
begin
  Timer1.Enabled:=False;
  BitBtn1_Start.Enabled:=True;
  SB1_Stop.Enabled:=False;
  SB2_Reverse.Enabled:=True;
  BZapiszDAT.Enabled:=True;
end;

procedure TForm1.SB2_ReverseClick(Sender: TObject);
begin
  Hini:=StrToFloat(Edit_startF.Text);
  Hini:=-Hini;
  Edit_startF.Text:=FloatToStr(Hini);
  deltaH:=StrToFloat(Edit_stepF.Text);
  deltaH:=-deltaH;
  Edit_stepF.Text:=FloatToStr(deltaH);
  Hfin:=Hini+deltaH*Nstep;
  Label_endF.Caption:='fin. field: '+FloatToStrF(Hfin,ffGeneral,5,7)+' kA/m';
  BZapiszDAT.Enabled:=False;
  BitBtn1_Start.Enabled:=false;
  SB2_Reverse.Enabled:=False;
  st:=0;
  SB1_Stop.Enabled:=True;
  Timer1.Enabled:=True; {start liczenia w druga strone}
end;

procedure TForm1.BZapiszDATClick(Sender: TObject);
var i,j: integer;
begin
  if rowSimul>0 then
   begin
    SaveDialog1.Execute;
    assignfile(fout,SaveDialog1.FileName);
    rewrite(fout); {TODO: zabezpieczyc przed bledami}
    for i:=1 to rowSimul do
     begin
       for j:=1 to maxdatar do
         write(fout,DataSim[j,i],'    ');
       writeln(fout);
     end;
    closefile(fout);
    BZapiszDAT.Enabled:=False;
   end;
end;

procedure TForm1.RadioGroup_pClick(Sender: TObject);
begin
  ClearScreen;
  ReplotData(DataExp[ActX],DataExp[ActY],rowFilled);
end;

procedure TForm1.BReplot2Click(Sender: TObject);
begin
  ScrollBarHP.Enabled:=false;
  ClearScreen;
  if rowFilled>0 then
   begin
     Form1.ReplotData(DataExp[ActX],DataExp[ActY],rowFilled);
   end;
  if rowSimul>0 then
   begin
     plotpattern:=LineSolid;
     Form1.ReplotData(DataSim[ActX],DataSim[ActY],rowSimul);
   end;
end;

procedure TForm1.ScrollBar1aChange(Sender: TObject);
begin
  ScrollBar1a.Hint:='1st layer anisotropy angle: '+IntToStr(ScrollBar1a.Position);
  alpha[1]:=ScrollBar1a.Position*Pi/180;
  ClearVectorScreen;
end;

procedure TForm1.ScrollBar2aChange(Sender: TObject);
begin
  ScrollBar2a.Hint:='2nd layer anisotropy angle: '+IntToStr(ScrollBar2a.Position);
  alpha[2]:=ScrollBar2a.Position*Pi/180;
  ClearVectorScreen;
end;

procedure TForm1.ScrollBar3aChange(Sender: TObject);
begin
  ScrollBar3a.Hint:='3rd layer anisotropy angle: '+IntToStr(ScrollBar3a.Position);
  alpha[3]:=ScrollBar3a.Position*Pi/180;
  ClearVectorScreen;
end;

procedure TForm1.ScrollBar4aChange(Sender: TObject);
begin
  ScrollBar4a.Hint:='4rd layer anisotropy angle: '+IntToStr(ScrollBar4a.Position);
{  alpha[4]:=ScrollBar4a.Position*Pi/180;  !!!}
  ClearVectorScreen;
end;

procedure TForm1.ScrollBarHAChange(Sender: TObject);
begin
  ScrollBarHA.Hint:='Field angle: '+IntToStr(ScrollBarHA.Position);
  Hangle:=ScrollBarHA.Position*Pi/180;
  ClearVectorScreen;
end;

procedure TForm1.RadioGroup_pxClick(Sender: TObject);
begin
  if colFilled>=RadioGroup_px.ItemIndex+1 then
   ActX:=RadioGroup_px.ItemIndex+1;
  ClearScreen;
  ReplotData(DataExp[ActX],DataExp[ActY],rowFilled);
end;

procedure TForm1.RadioGroup_pyClick(Sender: TObject);
begin
  if colFilled>=RadioGroup_py.ItemIndex+1 then
   ActY:=RadioGroup_py.ItemIndex+1;
  ClearScreen;
  ReplotData(DataExp[ActX],DataExp[ActY],rowFilled);
end;

procedure TForm1.BNormalizeSimClick(Sender: TObject);
var i: integer; norm:real;
begin
  if DataSim[2,1]<>0 then
   norm:=abs(DataSim[2,1])
  else
   norm:=1.0;
  for i:=2 to rowSimul do
   DataSim[2,i]:=DataSim[2,i]/norm;

  PlotNewData;
  ClearScreen;
  ScrollBarHP.Enabled:=false;
  if rowFilled>0 then
   begin
     Form1.ReplotData(DataExp[ActX],DataExp[ActY],rowFilled);
   end;
  if rowSimul>0 then
   begin
     plotpattern:=LineSolid;
     Form1.ReplotData(DataSim[ActX],DataSim[ActY],rowSimul);
   end;

end;



end.
