program energy_evaluation_afm;
uses graph,graph0,bgidriv,bgifont,dos,crt{,utils};

Const NLayers=3;    {ile warstw magn.}
      dimension=NLayers;
      MAX = 300;

TYPE
   glnarray = ARRAY [1..dimension] OF extended;
{   glnbyn = ARRAY [1..dimension,1..dimension] OF extended; }

const alpha1:real=0;
      alpha2:real=0;
      alpha3:real=0;

      dimm = 65;
      Ymagnify:real=5000.0; {500}
      YNormalize=10.0;
      ShowDimensions:integer=12;
var
   matrix : ARRAY [1..dimm,1..dimm] of real;
   theta: glnarray; {dla potrzeb 3D}
   X0, Y0, Z0, zoom, beta, phi: real;
   sinbeta,cosbeta,sinphi,cosphi:real;
   Xasp,Yasp:word;
   kp:char;
   ColorS: integer;
   twoPi:real;
   Ju1,Eeb,ku1,ku2,ku3,Hu,t1,t2,t3,Ms1,Ms2,Ms3,tstep:real;
   KAxis: integer;
   Nstep:integer;
   thetaini1,thetaini2,thetaini3,Hini:real;

   t,g:glnarray;    {theta1, theta2 oraz gradient}

   x : array [ 1..MAX ] of extended;
   ncom,a,nc: integer;
   pcom,xicom: glnarray;
   Magn,ksi:extended;
   fout:text;
   ftol,fret :extended;
   iter,maxiter: integer;
   ii,i,j : integer;
   lpom : integer;

   Ramp:real;         {default= 0.05;  Random amplitude}

   PageNo: boolean;

{ wprowadzam parametry funkcji  - initial variable parameters}

procedure initvar;
var
    i:integer;
begin
   write('Give linear Ju1=');
   readln(Input,Ju1);
   writeln(Ju1);
   write('Give exchange bias Eeb=');
   readln(Input,Eeb);
   writeln(Eeb);
   write('Give Ku1=');
   readln(Input,Ku1);
   writeln(Ku1);
   write('Give Ku2=');
   readln(Input,Ku2);
   writeln(Ku2);
   write('Give KuAF=');
   readln(Input,Ku3);
   writeln(Ku3);
   write('Give K Axis=');
   readln(Input,KAxis);
   writeln(KAxis);
   write('Give thickness1=');
   readln(Input,t1);
   writeln(t1);
   write('Give thickness2=');
   readln(Input,t2);
   writeln(t2);
   write('Give thickness3=');
   readln(Input,t3);
   writeln(t3);
   write('Give Ms1=');
   readln(Input,Ms1);
   writeln(Ms1);
   write('Give Ms2=');
   readln(Input,Ms2);
   writeln(Ms2);
   write('Give Ms3=');
   readln(Input,Ms3);
   writeln(Ms3);
   writeln;
   write('Give initial H=');
   readln(Input,Hini);
   write('Give H step=');
   readln(Input,Ksi);
   write('Give Steps No=');
   readln(Input,NStep);
   writeln('Maximum field=',Hini+NStep*Ksi:7:2);

   write('Random=');
   readln(Input,Ramp);
   writeln('RND =',Ramp:5:3);
   if (ParamCount>0) and not eof(Input) then
    begin
      readln(Input,alpha1);
      alpha1:=alpha1/180*Pi;
      writeln(alpha1);
      readln(Input,alpha2);
      alpha2:=alpha2/180*Pi;
      writeln(alpha2);
      readln(Input,alpha3);
      alpha3:=alpha3/180*Pi;
      writeln(alpha3);
    end;

{
   write('Give initial theta1=');
   readln(thetaini1);
   write('Give initial theta2=');
   readln(thetaini2);
}
  thetaini1:=-2*Pi;
  thetaini2:=-2*Pi;
  thetaini3:=-(2.5*Pi-alpha3);

  repeat until keypressed;
end;


procedure OpenParameterFile;
var PStr,OutStr:PathStr;
begin
  If ParamCount>=1 then
   PStr:=ParamStr(1)
  else PStr:='';
  If PStr<>'' then
  assign(Input,PStr);
{$I-}
  reset(Input);
{$I+}
If IOresult<>0 then begin writeln('Invalid file name!'); halt(0) end;
   if Pstr='' then OutStr:='mloop.dat'
    else
     OutStr:=Copy(PStr,1,Length(PStr)-4)+'.dat';
   InitVar;
   assign(fout,OutStr);
   rewrite(fout);
   writeln(fout,'J1=',Ju1:6,'   Eeb=',Eeb:4,'   K1=',ku1:5,'  K2=',ku2:5,'  Kaf=',ku3:5);
   writeln(fout,'t1=',t1:6,'   t2=',t2:4,', t3=',t3:4,'   Ms1=',Ms1:5,'  Ms2=',Ms2:5,'  Ms3=',Ms3:5);
   writeln(fout,'Hini=',Hini:6,'   Hstep=',Ksi:4,'   Nstep=',Nstep:5,'  Random=',Ramp);
   writeln(fout);
   writeln(fout,' H [A/m]                   u.Ms [T]    t1[deg] t2[deg] t3[deg]');
   writeln(fout,'@');
   close(Input);
end;



{****************************************************************}
{TU ZACZYNAM WPROWADZAC SWOJA FUNKCJE }
{Function of Energy density }
{*****************************************************************}

function fnc(var t:glnarray ):extended;
var energia,cost12:real;
begin
 cost12:=cos(t[1]-t[2]);
 energia := -Hu*Ms1*t1*cos(t[1]) -Hu*Ms2*t2*cos(t[2]) -Hu*Ms3*t3*cos(t[3])
             -Eeb*cos(t[2]-t[3]) - Ju1*cos(t[1]-t[2]);
 case KAxis of
{anizotropia jednoosiowa}
  1 : energia:=energia+Ku1*t1*sqr(cos(t[1]-alpha1)) +Ku2*t2*sqr(cos(t[2]-alpha2)) +Ku3*t3*sqr(cos(t[3]-alpha3)) ;
{anizotropia kwadratowa}
  2 : energia:=energia+Ku1*t1*sqr(cos(t[1]-alpha1))*sqr(sin(t[1]-alpha1)) +Ku2*t2*sqr(cos(t[2]-alpha2))*sqr(sin(t[2]-alpha2))
                      +Ku3*t3*sqr(cos(t[3]-alpha3))*sqr(sin(t[3]-alpha3));
 end;
 fnc:=energia*YNormalize;
end;

{*****************************************************}
{    koniec wprowadzania funkcji }
{*****************************************************}



{ $ I mnbrak1.pas}
{ $ I brent.pas}

{***************************************************}
{ PROCEDURA LICZACA GRADIENT MOJEJ FUNKCJI   }
{ Procedure computing gradient of FNC        }
{***************************************************}

procedure grad(var t:glnarray; var g:glnarray);
begin
{ procedura ta ma liczyc gradient funkcji danej }

  g[1]:=Ju1*sin(t[1]-t[2])+Hu*Ms1*t1*sin(t[1]);
  g[2]:=-Ju1*sin(t[1]-t[2])+Eeb*sin(t[2]-t[3])+Hu*Ms2*t2*sin(t[2]);
  g[3]:={Hu*Ms3*t3*sin(t[3])}-Eeb*sin(t[2]-t[3]);

 case KAxis of
{anizotropia jednoosiowa}
 1 : begin
       g[1]:=g[1]-2*Ku1*t1*cos(t[1]-alpha1)*sin(t[1]-alpha1);
       g[2]:=g[2]-2*Ku2*t2*cos(t[2]-alpha2)*sin(t[2]-alpha2);
       g[3]:=g[3]-2*Ku3*t3*cos(t[3]-alpha3)*sin(t[3]-alpha3);
     end;
{anizotropia kwadratowa}
 2 : begin
       g[1]:=g[1]+0.5*Ku1*t1*cos(4*(t[1]-alpha1));
       g[2]:=g[2]+0.5*Ku2*t2*cos(4*(t[2]-alpha2));
       g[3]:=g[3]+0.5*Ku3*t3*cos(4*(t[3]-alpha3));
     end;
 end;

  g[1]:=g[1]*YNormalize;
  g[2]:=g[2]*YNormalize;
  g[3]:=g[3]*YNormalize;
end;

{************************************************* end }


function NormSampling:real;
const sampno=20;
var js:integer; suma:real;
    ts:glnarray;
begin
  suma:=1e-12;
  randomize;
  for js:=1 to sampno do
   begin
    ts[1]:=-2*Pi+4*Pi*random;
    ts[2]:=-2*Pi+4*Pi*random;
    ts[3]:=-2*Pi+4*Pi*random;
    suma:=suma+sqr(fnc(ts));
  end;
  suma:=sqrt(suma/sampno);
  NormSampling:=suma;
end;

function Magnetization(theta1,theta2,theta3:real):real;
var TotalT: real;
begin
{  Magnetization:=(Ms1*cos(theta1)+Ms2*cos(theta2))/NLayers; }
{srednia wazona:}
  TotalT:=0;
  if Ms1>0 then TotalT:=t1;
  if Ms2>0 then TotalT:=TotalT+t2;
  if Ms3>0 then TotalT:=TotalT+t3;
  if TotalT>0 then
   Magnetization:=(t1*Ms1*cos(theta1)+t2*Ms2*cos(theta2)+t3*Ms3*cos(theta3))/(TotalT)
  else
   begin
    writeln('thickenss<=0');
    halt(0);
  end;
end;

{$I auxil.pas}

Procedure XYZ2s(x,y,z:real;var xe,ye:integer);
const d=100.0;
var  xx,yy,zz:real;
begin

  zz:=z+Z0;
  xx:=x+X0;
  yy:=y+Y0;
  x:=xx*cosbeta-yy*sinbeta;
  y:=xx*sinbeta+yy*cosbeta;
  yy:=y*cosphi-zz*sinphi;
  z:=y*sinphi+zz*cosphi;
  xe:=trunc(zoom*d*x/(yy+d)+Xasp);
  ye:=-trunc(zoom*d*z/(yy+d)-Yasp);
end;

procedure DisplayP3D(x,y,z:real;color:word);
var xe,ye:integer;
begin
  XYZ2s(x,y,z,xe,ye);
  Putpixel(xe,ye,color);
  MoveTo(xe,ye);
end;

procedure DisplayL3D(x,y,z:real; color:word);
var xe,ye:integer;
begin
  XYZ2s(x,y,z,xe,ye);
  SetColor(color);
  LineTo(xe,ye);
end;

procedure DisplayS3D(x1,y1,z1,x2,y2,z2:real; color:word);
var xe1,ye1,xe2,ye2:integer;
begin
  XYZ2s(x1,y1,z1,xe1,ye1);
  XYZ2s(x2,y2,z2,xe2,ye2);
  SetColor(color);
  Line(xe1,ye1,xe2,ye2);
end;


   procedure DisplayReal(PrefikS:string; InputReal:real;acc,X,Y:integer; SuffikS:String);
   var displej:string;
   begin
     Str(InputReal:8:acc,displej);
     SetColor(3);
     OutTextXY(X,Y,'                      ');
     OutTextXY(X,Y,PrefikS+displej+SuffikS);
   end;

{$I gradmin.pas}


Begin  {of the program}
   clrscr;

   twoPi:=2*Pi;

   {InitVar;}
   OpenParameterFile;
   {close(Input);}

                        LoadDrivers;
                        StartGraphScreen;
                        Xasp:=GetMaxX div 2;
                        Yasp:=GetMaxY div 2;

   ftol:=0.0000000002;
   maxiter:=9000;

   Hu:=Hini;

{   if Hini<0 then
    begin }
     t[1]:=Pi;
     t[2]:=Pi;
     t[3]:=thetaini3;
{    end
   else
    begin
     t[1]:=0;
     t[2]:=0;
     t[3]:=0;
    end;
}
   {param grafiki 3D}
   X0:=0.3;
   Y0:=-0.1;
   Z0:=0.5;
   zoom:=35;
   beta:=-1.9 {1.6};
   phi:=0.5 {-0.5};
              sinbeta:=sin(beta);
              cosbeta:=cos(beta);
              sinphi:=sin(phi);
              cosphi:=cos(phi);

  PageNo:=False;
{
  SetVisualPage(ord(PageNo));
  SetActivePage(ord(not PageNo));
}
   for ii:=1 to Nstep do
    begin
  SetVisualPage(ord(PageNo));
  SetActivePage(ord(not PageNo));
  ClearViewPort;
  ClearDevice;

     t[3]:=t[3]+Ramp-random(10)*Ramp/5;
     t[2]:=t[2]+Ramp-random(10)*Ramp/5;
     t[1]:=t[1]+Ramp-random(10)*Ramp/5;

   tstep:=0.2;
   theta[1]:=thetaini1;
   theta[2]:=thetaini2;
   theta[3]:=thetaini3;

      {losie}
      DisplayP3D(twoPi,twoPi,0,6);
      DisplayL3D(-twoPi,twoPi,0,6);
      DisplayP3D(-twoPi,twoPi,0,6);
      DisplayL3D(-twoPi,-twoPi,0,6);
      DisplayP3D(-twoPi,-twoPi,0,6);
      DisplayL3D(twoPi,-twoPi,0,6);
      DisplayP3D(twoPi,-twoPi,0,6);
      DisplayL3D(twoPi,twoPi,0,6);
      {osie}
      DisplayP3D(0,0,0,1);
      DisplayL3D(1,0,0,1);
      DisplayP3D(0,0,0,1);
      DisplayL3D(0,1,0,1);
      DisplayP3D(0,0,0,1);
      DisplayL3D(0,0,1.0,1);
      {-}
      SetLinestyle(DashedLn,0,1);
      DisplayP3D(0,0,0,3);
      DisplayL3D(-1,0,0,3);
      DisplayP3D(0,0,0,3);
      DisplayL3D(0,-1,0,3);
      DisplayP3D(0,0,0,3);
      DisplayL3D(0,0,-1.0,3);
      SetLinestyle(SolidLn,0,1);


   for i:=1 to dimm do
    begin
      theta[1]:=thetaini1;
      theta[2]:=theta[2]+tstep;
      theta[3]:=t[3];
      {
       matrix[1,i]:=Ymagnification*fnc(theta);
       DisplayP3D(theta[1],theta[2],matrix[1,i],2);
       }
       for j:=1 to dimm do
        begin
          theta[1]:=theta[1]+tstep;
          matrix[j,i]:=Ymagnify*fnc(theta);
          {
          DisplayL3D(theta[1],theta[2],matrix[j,i],2);
          }
          if j>1 then
           begin
             if (matrix[j,i]<0) and (matrix[j-1,i]<0) then
              begin
                ColorS:=green
              end
             else
             if (matrix[j,i]>0) and (matrix[j-1,i]>0) then
              begin
                ColorS:=red
              end
             else
              begin
                ColorS:=yellow
              end;
             DisplayS3D(theta[1],theta[2],matrix[j,i],
                        theta[1]-tstep,theta[2],matrix[j-1,i],ColorS);
           end;
        end;
    end;

{
  SetVisualPage(ord(not PageNo));
  SetActivePage(ord(not PageNo));
}
{      dfpmin(t,dimension,ftol,a,fret); }

      iter:= GradMin(t,1/NormSampling,0.1,ftol,maxiter);
      if iter<maxiter then
       begin
         SetLinestyle(DottedLn,0,1);
         DisplayP3D(twoPi,t[2],0,2);
         DisplayL3D(t[1],t[2],0,5);
         DisplayP3D(t[1],twoPi,0,2);
         DisplayL3D(t[1],t[2],0,5);
         DisplayP3D(t[1],t[2],0,2);
       end;
      SetLinestyle(SolidLn,0,1);
      DisplayL3D(t[1],t[2],Ymagnify*fnc(t),5);


      Magn:=Magnetization(t[1],t[2],t[3]);

    DisplayReal('M= ',Magn,2,520,290,' T');
    DisplayReal('t1=',t[1]/Pi,2,520,300,'Pi');
    DisplayReal('t2=',t[2]/Pi,2,520,310,'Pi');
    DisplayReal('t3=',t[3]/Pi,2,520,320,'Pi');
    DisplayReal('H=',Hu,0,520,330,' A/m');
    DisplayReal('iter=',iter,0,520,340,' ');

    writeln(fout,Hu,' ',Magn,' ',t[1]*180/Pi:4:1,' ',t[2]*180/Pi:4:1,' ',t[3]*180/Pi:4:1,' ',iter:5);

    Hu:=Hu+Ksi;



  if keypressed then
   begin
     kp:=readkey;
     case kp of
       'l' :  X0:=X0-0.1;
       'r' :  X0:=X0+0.1;
       'b' :  Y0:=Y0-0.1;
       'f' :  Y0:=Y0+0.1;
       'u' :  Z0:=Z0-0.1;
       'd' :  Z0:=Z0+0.1;
       'o' :  zoom:=zoom-0.1;
       'i' :  zoom:=zoom+0.1;
       'n' :  YMagnify:=1/NormSampling;
       '1' :  ShowDimensions:=13;
       '2' :  ShowDimensions:=12;
       '3' :  ShowDimensions:=23;
       #0 : if keypressed then
            begin
              kp:=readkey;
              case kp of
              LEFT : beta:=beta-0.1;
              RIGHT: beta:=beta+0.1;
              UP   : phi:=phi+0.1;
              DOWN : phi:=phi-0.1;
              end;
              sinbeta:=sin(beta);
              cosbeta:=cos(beta);
              sinphi:=sin(phi);
              cosphi:=cos(phi);
           end;
     end;
   end;

  PageNo:=not PageNo;
  {
  SetVisualPage(ord(not PageNo));
  SetActivePage(ord(PageNo));
  }
  delay(5);

  end; {petla przemagnesowania}

  repeat until keypressed;

  closegraph;


   close(fout);
   
end.